// -*-java-*-
// $Id: load.js,v 1.8 2007/08/21 08:10:30 asc Exp $

// http://www.aaronland.info/weblog/2007/07/28/trees/#delmaps
// Copyright (c) 2007 Aaron Straup Cope. All Rights Reserved.
// This is free software, you may use it and distribute it under the
// same terms as Perl itself.

var load_json = function(del_json){

    var len = del_json.length;
    var places = new Array();

    var re_geo = new RegExp(/^geo\:(lat|lon)=(-?\d+(?:\.\d+)?)$/);

    for (var i=0; i < len; i++){

        var post = del_json[i];
        var tags = post.t;
        var tlen = tags.length;

        var point = {};

        for (var j=0; j < tlen; j++){

            var t = tags[j];

            if (m = re_geo.exec(t)){
                point[m[1]] = m[2];
            }
        }

        if ((point['lat']) && (point['lon'])){
            point['title'] = post.d;
            point['description'] = post.n;
            point['url'] = post.u;
            point['tags'] = tags;
            places.push(point);
        }
    }

    if (places.length){
        map.removeMarkersAll();
        plot_places(places);
    }
}

function onMarkerMouseOver(evt){
    if (evt.thisObj.BarcodeCurrent){
        evt.thisObj.SetBarcodeHTML(evt.thisObj.BarcodeCurrent);
    }

}

function show_bookmark_carousel(cid){
    
    var args = {
        numVisible:1,
        scrollInc:1,
        animationSpeed:0,
        prevElement:cid + "_prev_arrow",
        nextElement:cid +  "_next_arrow",
    };
    
    carousel = new YAHOO.extension.Carousel(cid, args); 
    carousel.show();
}

function onMarkerClick(evt){
    
    // please to properly remove event
    if (skip) { skip=0; return; }

    var points = new Array(evt.thisObj.YGeoPoint);
    var best = map.getBestZoomAndCenter(points);
    map.drawZoomAndCenter(best.YGeoPoint, best.zoomLevel + 1);
    // evt.thisObj.openAutoExpand();
}

function plot_places(places){

    var len = places.length;
    var points = new Array();

    for (var i=0; i < len; i++){
        var pnt = plot_place(places[i]);
        points.push(pnt);
    }

    var best = map.getBestZoomAndCenter(points);
    map.drawZoomAndCenter(best.YGeoPoint, best.zoomLevel + 1);
}

function plot_place(pl){
    lat = parseFloat(pl.lat);
    lon = parseFloat(pl.lon);

    var geo = new YGeoPoint(lat, lon);
    var id = delmaps_tagify(String(lat) + String(lon));
    var m = new YMarker(geo, null, id); 

    var s = new sanitize()
    var cl_desc = s.sanitize_string(pl.description);

    var rb = new Restobook();

    if (rb.parse(pl.description)){
        cl_desc = rb.asHTML();
    }

    var tags = new dmTags(pl.tags);
    var str_tags = tags.asHTML();

    // please for you to move me in to a function...

    var cl_title = s.sanitize_string(pl.title);
    var cl_url = s.sanitize_url(pl.url);
    var b_url = btoa(pl.url);

    var cl_id = s.sanitize_string(encodeURIComponent(id));

    //

    m.Barcodes = {'link':cl_url, 'edit':del_edit_url(pl.url)}

    /*
    var yelp = rb.get("yelp", "raw");

    if (yelp){
        cl_y = s.sanitize_url(rb.yelp_url(yelp, "mobile"));
        m.Barcodes['yelp'] = cl_y;
    }
    */

    var phone = rb.get("phone", "raw");

    if (phone){
        m.Barcodes['phone'] = s.sanitize_string(phone);
    }

    m.BarcodeCarouselId = dmGenerateBarcodeCarouselId(pl.url);
    m.BarcodeCurrent = null;
    m.BarcodeHTML = {};

    m.SetBarcodeHTML = function(label){
        url = this.Barcodes[label];

        var id = this.BarcodeCarouselId;


        var list = document.getElementById(id + "_list");
        var cl = list.lastChild.style.display = "inline";
        var aanchor = null;

        var kids = list.childNodes.length;

        for (var i=0; i < kids; i++){
            var weight = 100;

            var item = list.childNodes[i];
            var anchor = item.getElementsByTagName("a")[0];
            anchor.style.color = "blue";

            if (item.getAttribute("class") == "carousel_list_item_"+label){
                weight = 700;

                anchor.innerHTML = "..."; 
                anchor.style.color = "#ccc";
                
                aanchor = anchor;
            }

            item.style.fontWeight = weight;
        }

        if (! this.BarcodeHTML[url]){
            bar = new dmBarcode(url);
            this.BarcodeHTML[url] = bar.asDOM();
        }

        var div = document.getElementById(id);        
        div.innerHTML = this.BarcodeHTML[url].innerHTML;
        aanchor.innerHTML = label;

        this.BarcodeCurrent = label;
    };

    m.HideBarcodeHTML = function(){
        var id = this.BarcodeCarouselId;
        var div = document.getElementById(id);

        var list = document.getElementById(id + "_list");
        var cl = list.lastChild.style.display = "none";

        var kids = list.childNodes.length;

        for (var i=0; i < kids; i++){
            var item = list.childNodes[i];
            var anchor = item.getElementsByTagName("a")[0];
            item.style.fontWeight = 100;
            anchor.style.color = "blue";
        }

        div.innerHTML = '';
        this.BarcodeCurrent = null;
    };

    var barcode_carousel = "<div class=\"carousel_wrapper\">";
    barcode_carousel += "<div id=\""+m.BarcodeCarouselId+"\" class=\"carousel_barcode\"></div>";
    barcode_carousel += "<ul class=\"carousel_list\" id=\""+m.BarcodeCarouselId+"_list\">";

    for (var label in m.Barcodes){
        var label_id = m.BarcodeCarouselId + "_" + label;
        barcode_carousel += "<li class=\"carousel_list_item_"+label+"\"><a href=\"#\" onclick=\"javascript:skip=1;m=map.getMarkerObject('"+cl_id+"');m.SetBarcodeHTML('"+label+"');return false;\">" + label + "</a></li>";
    }

    barcode_carousel += "<li style=\"display:none;\"><a href=\"#\" style=\"color:#ccc;\" onclick=\"javascript:skip=1;m=map.getMarkerObject('"+cl_id+"');m.HideBarcodeHTML();return false;\">x</a></li>";
    barcode_carousel += "</ul>";
    barcode_carousel += "</div>";

    //

    m.addLabel("<img src=\"http://del.icio.us/favicon.ico\" height=\"10\" width=\"10\" style=\"margin-top:6px;margin-left:6px;\"/>");
    m.addAutoExpand("<div class=\"delmaps_marker\"><a target=\"_" + cl_id + "\" class=\"delmaps_locname\" href=\"" + cl_url + "\">" + cl_title + "</a> <a href='#' onclick='editMarker(\"" + b_url + "\");return false;'><img src=\"http://del.icio.us/favicon.ico\" height=\"10\" width=\"10\" style=\"margin-top:6px;margin-left:6px;border:none;\"/></a><br />" + cl_desc + str_tags + barcode_carousel + "<div class=\"delmaps_marker_close\"><a href=\"#\" onclick=\"m=map.getMarkerObject('" + cl_id + "');m.closeAutoExpand();return false;\">x</a></div></div>");

    m.setSmartWindowColor("brown");

    YEvent.Capture(m, EventsList.MouseOver, onMarkerMouseOver);

    // why does this only work for MouseClick?
    YEvent.Capture(m, EventsList.MouseClick, onMarkerClick);
    //YEvent.Capture(m, EventsList.MouseDoubleClick, onMarkerClick);

    map.addOverlay(m);

    return geo;
}

function load_tag(user, tag){
    load_user(user, tag);
    set_permalink(user, tag);
}

function set_permalink(user, tag){
    var stz = new sanitize();
    var cl_user = stz.sanitize_url_string(user);
    var cl_tag = stz.sanitize_url_string(tag);
    var href = "?user=" + cl_user + "&tag=" + cl_tag;

    var pm = document.getElementById("permalink");
    pm.setAttribute("href", href);
}

function load_user(user, tag){

    var tags = new Array();

 	if (tag){
            tags.push(tag);
        }

        load_places(user, tags);
}

var load_places = function(user, tags){
    tags.push('del:bookmark=geo');
    var url = "http://del.icio.us/feeds/json/" + user + "/" + tags.join("+");
    url += "?callback=load_json";
    delmaps_JSR(url);
};
