// -*-java-*-
// $Id: yelp.js,v 1.4 2007/08/19 16:39:44 asc Exp $

function onYelpSearch (json) {

    var points = new Array();

    for (var i in json.businesses) {
        if (filterYelpBusiness(json.businesses[i])){
            points.push(plotYelpBusiness(json.businesses[i]));
        }
    }

    //var best = map.getBestZoomAndCenter(points);
    //map.drawZoomAndCenter(best.YGeoPoint, best.zoomLevel + 1);    
}

function doYelpSearch (lat, lon) {
    var args = {'lat':lat, 'long':lon, 'radius':1, 'callback':'onYelpSearch','category':'restaurants'};
    var yelp = yelpObj();
    yelp.search(args);
}

function yelpObj () {
    return new Yelp('5_SbHp5VFGmW-vZ7PPIiWQ');
}

function filterYelpBusiness(b){
    return 1;
}

function plotYelpBusiness(b){

    var geo = new YGeoPoint(parseFloat(b.latitude), parseFloat(b.longitude));
    var id = b.id;
    var mrk = new YMarker(geo, null, id); 

    mrk.addLabel("<img src=\"http://www.yelp.com/favicon.ico\" height=\"14\" width=\"14\" style=\"margin-top:4px;margin-left:4px;\"/>");
    mrk.addAutoExpand("<strong>" + b.name + "</strong>");

    YEvent.Capture(mrk, EventsList.MouseClick, postYelpItem);

    mrk.Yelp = b;
    map.addOverlay(mrk);

    return geo;
}

function postYelpItem (evt) {

    // please for you to reconcile with 'do_post'

    var mrk = evt.thisObj;
    var pos = mrk.YGeoPoint;

    var lat = pos.Lat;
    var lon = pos.Lon;

    var tags = new Array();

    tags.push(delmaps_tagify(mrk.Yelp.city));

    for (var i in mrk.Yelp.neighborhoods){
        tags.push(delmaps_tagify(mrk.Yelp.neighborhoods[i].name));
    }

    for (var i in mrk.Yelp.categories){
        tags.push(delmaps_tagify(mrk.Yelp.categories[i].category_filter));
    }

    tags.push("del:bookmark=geo");
    tags.push("geo:lat=" + lat);
    tags.push("geo:lon=" + lon);

    gt = new Geotude({'latitude':lat,'longitude':lon});
    geotude = gt.geotude();

    if (geotude[0]){
        tags.push('geotude:major=' + geotude[0]);
        tags.push('geotude:minor=' + geotude[1]);
    }

    var str_tags = tags.join(" ");

    var addr = new Array(mrk.Yelp.address1, mrk.Yelp.address2, mrk.Yelp.city, mrk.Yelp.state, mrk.Yelp.zip);
    var rb = new Restobook();
    rb.yelp(mrk.Yelp.id);
    rb.phone(mrk.Yelp.phone);
    rb.address(addr.join(" "));

    var uri   = encodeURIComponent(mrk.Yelp.url);
    var notes = encodeURIComponent(rb.stringify());
    var str_tags = encodeURIComponent(str_tags);
    var title = encodeURIComponent(mrk.Yelp.name);

    send_post(uri, notes, str_tags, title);    
}
