// -*-java-*-

function sanitize(){
    this._stub = "OH HAI";
}

sanitize.prototype.sanitize_string = function(str){

    str = this.decode_html_entities(str);

    // http://www.owasp.org/index.php/Cross_Site_Scripting
    // fix dangling ";"...

    str = str.replace(/&/g,  "&amp;");
    str = str.replace(/;/g,  "&#59;");
    str = str.replace(/#/g, "&#35;");
    str = str.replace(/%/g,  "&#37;");
    str = str.replace(/>/g,  "&gt;");
    str = str.replace(/</g,  "&lt;");
    str = str.replace(/\+/g, "&#43;");
    str = str.replace(/-/g,  escape("-"));
    str = str.replace(/"/,   "&quot;");
    str = str.replace(/'/g, "&apos;");
    str = str.replace(/\(/g, "&#40;");
    str = str.replace(/\)/g, "&#41;");

    return str;
}

sanitize.prototype.sanitize_url_string = function(str){

    if (! str){
        return;
    }

    str = decodeURIComponent(str);
    str = encodeURIComponent(str);

    str = str.replace(/"/g,  escape('"'));
    str = str.replace(/\(/g, escape("("));
    str = str.replace(/\)/g, escape(")"));
    return str;
};

sanitize.prototype.sanitize_url = function(url){

    url = this.decode_html_entities(url);

    // http://www.flog.co.nz/index.php/journal/prototype-uri-parser-class/
    var re = new RegExp(/^((\w+):\/\/)?((\w+):?(\w+)?@)?([^\/\?:]+):?(\d+)?(\/?[^\?#]+)?\??([^#]+)?#?([\.\w,]*)/);
    var url = re.exec(url);

    if (! url){
        return "#";
    }

    var protocol = url[2];

    if (! protocol){
        return "#";
    }

    // this.username	= this._getVal(r,4);
    //this.password	= this._getVal(r,5);
    var host = url[6];
    var port = url[7];
    var pathname = url[8];
    var querystring = url[9];
    var fragment = url[10];

    clean  = this.sanitize_url_string(protocol);
    clean += "://";
    clean += this.sanitize_url_string(host);

    if (port){
	clean += ":";
	clean += port;
    }

    clean += "/";

    pathname = pathname.replace("/", "");
                      
    if ((pathname) && (pathname!='/')){
        var pathname = pathname.split("/");
        var path = new Array();

        for (var i in pathname){
            path.push(this.sanitize_url_string(pathname[i]));
        }

        if (path.length){
            clean += path.join("/");
        }
    }

    if (querystring){

        var querystring = querystring.split("&");
        var query = new Array();
        
        for (var i in querystring){
            var parts = querystring[i].split("=");
            var param = this.sanitize_url_string(parts[0]);
            var value = this.sanitize_url_string(parts[1]);
            query.push(param + "=" + value);
        }

        if (query.length){
            clean += ("?");
            clean += query.join("&");
        }
    }

    if (fragment){
        clean += "#";
        clean += this.sanitize_url_string(fragment);
    }

    return clean;
};

sanitize.prototype.decode_html_entities = function(str){
    str = str.replace(/&apos;/g, "'");
    str = str.replace(/&quot;/g, '"');
    str = str.replace(/&amp;/g, "&");
    return str;
};
